
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

flash unsigned int row[]={0x00001,0x00002,0x0004,0x0008,0x0010,0x0020,0x0040,0x0080,0x0100,0x0200,0x0400,0x0800,0x1000,0x2000,0x4000,0x8000,};
flash unsigned int col[]={0x00,0x00,0x6306,0x3306,0x1b06,0xf06,0x706,0xf06,0x1b06,0x3306,0x637e,0x637e,0x00,0x00,0x00,0x00}; 

unsigned int Color;  

interrupt [17] void timer0_ovf_isr(void)
{
static int i=0;
i++;
if(i==500)
{
i=0;
Color++;
if(Color==3)
{
Color=0;
}
}
TCNT0+=6;
} 

void row0_on()
{
PORTC=~(0X50);PORTC=0x3f; 
}

void row1_on() 
{
PORTC=~(0X60);PORTC=0x3f; 
}

void column0_Red_led_on()
{
PORTC=~(0X44);PORTC=0x3f; 
}

void column1_Red_led_on()
{
PORTC=~(0X48);PORTC=0x3f;
}

void column0_Orange_led_on()
{
PORTC=~(0X41);PORTC=0x3f; 
}

void column1_Orange_led_on()
{
PORTC=~(0X42);PORTC=0x3f; 
}

void Dot_Full_Test() 
{
PORTD=0XFF; 
row0_on();
PORTD=0XFF; 
row1_on();

PORTD=0xff; 
column0_Orange_led_on();           
PORTD=0xff; 
column1_Orange_led_on();  

PORTD=0X00; 
column0_Red_led_on();  
PORTD=0X00; 
column1_Red_led_on();        

delay_ms(100);    

PORTD=0X00; 
row0_on();
PORTD=0X00; 
row1_on();

PORTD=0xff; 
column0_Orange_led_on();           
PORTD=0xff; 
column1_Orange_led_on();  

PORTD=0Xff; 
column0_Red_led_on();  
PORTD=0Xff; 
column1_Red_led_on();               
delay_ms(100);      
}
void main(void)
{

DDRD=0xFF; 
DDRC=0x7F; 
PORTC.6 =0; 

TCCR0=0X04; 
TCNT0=6;    
TIMSK=1;    
SREG=0X80;  

while(1) 
{                              
static unsigned int i,j=0; 
unsigned int col_a,row_a=0;                    
switch(Color)
{
case 0: 
for(j=0;j<16;j++){

row_a=row[j]; 
PORTD=(row_a&0xff);      
row0_on();
PORTD=(row_a>>8);   
row1_on();    

col_a=col[j];     
PORTD=(col_a&0xff); ; 
column0_Red_led_on();
PORTD=(col_a>>8);   ; 
column1_Red_led_on();

PORTD=0x00;     
column0_Orange_led_on();       
PORTD=0x00;        
column1_Orange_led_on();
delay_ms(1); 
}
break;

case 1:
for(j=0;j<16;j++){

row_a=row[j]; 
PORTD=(row_a&0xff);      
row0_on();
PORTD=(row_a>>8);   
row1_on();    

col_a=col[j];     
PORTD=(col_a&0xff); ; 
column0_Orange_led_on();
PORTD=(col_a>>8);   ; 
column1_Orange_led_on();

PORTD=0x00;     
column0_Red_led_on();       
PORTD=0x00;        
column1_Red_led_on();
delay_ms(1);      
}   
break;
case 2:  
for(j=0;j<16;j++){

row_a=row[j]; 
PORTD=(row_a&0xff);      
row0_on();
PORTD=(row_a>>8);   
row1_on();    

col_a=col[j];     
PORTD=(col_a&0xff); ; 
column0_Orange_led_on();
PORTD=(col_a>>8);   ;  
column1_Orange_led_on();

PORTD=(col_a&0xff); ;    
column0_Red_led_on();          
PORTD=(col_a>>8);   
column1_Red_led_on();   
delay_ms(1);    
}  
break;
}

}
}
