
/*===========================================================================================
Project : Dotmatrix Test
Version : LKM-DOTM-V01
Date    : 2011-07-28
Author  : Kyung Nam Lee
Company : LKEMBEDDED 
Compiler: WINAVR+AVRStudio 
Comment : 16*16ƮƮ ڸ ϴ α׷ ҽ̴.

10Pin Box ̺  Ʒ  ּ!
ATmega128-C Ȯ ߺ  PORTD <-------------> ƮƮ  - 10pڽĿ(PORT2)
ATmega128-C Ȯ ߺ  PORTC <-------------> ƮƮ  - 10pڽĿ(PORT0)
===========================================================================================*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/delay.h>

volatile unsigned int row[]={0x0001,0x0002,0x0004,0x0008,0x0010,0x0020,0x0040,0x0080,0x0100,0x0200,0x0400,0x0800,0x1000,0x2000,0x4000,0x8000,};
volatile unsigned int str[48][16]={   0xffff,0xffff,0xf607,0xf6ff,0xf6ff,0xf6ff,0xf6ff,0xc77f,0xf77f,0xf7bf,0xf7df,0xf7e7,0xf7ff,0xffff,0xffff,0xffff, //
                                   0xffff,0xffff,0xf7f7,0xf7f7,0xf7f7,0xf7f7,0xf7f7,0xc7f7,0xf7f7,0xf7f7,0xf7f7,0xf407,0xf7ff,0xffff,0xffff,0xffff, //
                                   0xffff,0xffff,0xf607,0xf7f7,0xf7f7,0xf7f7,0xf7f7,0xc7f7,0xf7f7,0xf7f7,0xf7f7,0xf407,0xf7ff,0xffff,0xffff,0xffff, // 
                                   0xffff,0xffff,0xf607,0xf6ff,0xf6ff,0xf6ff,0xf607,0xc7f7,0xf7f7,0xf7f7,0xf7f7,0xf407,0xf7ff,0xffff,0xffff,0xffff, // 
                                   0xffff,0xffff,0xf607,0xf6f7,0xf6f7,0xf6f7,0xf6f7,0xc6f7,0xf6f7,0xf6f7,0xf6f7,0xf607,0xf7ff,0xffff,0xffff,0xffff, //      
                                   0xffff,0xffff,0xf6f7,0xf6f7,0xf6f7,0xf6f7,0xf607,0xc6f7,0xf6f7,0xf6f7,0xf6f7,0xf607,0xf7ff,0xffff,0xffff,0xffff, //
                                   0xffff,0xffff,0xf7bf,0xf7bf,0xf7bf,0xf7bf,0xf7bf,0xc75f,0xf75f,0xf6ef,0xf6ef,0xf5f7,0xf7ff,0xffff,0xffff,0xffff, // 
                                   0xffff,0xffff,0xf70f,0xf6f7,0xf6f7,0xf6f7,0xf6f7,0xc6f7,0xf6f7,0xf6f7,0xf6f7,0xf70f,0xf7ff,0xffff,0xffff,0xffff, //         
                                   0xffff,0xffff,0xf407,0xf7bf,0xf7bf,0xf7bf,0xf7bf,0xc75f,0xf75f,0xf6ef,0xf6ef,0xf5f7,0xf7ff,0xffff,0xffff,0xffff, //  
                                   0xffff,0xffff,0xf607,0xf6ff,0xf6ff,0xf6ff,0xf607,0xc77f,0xf77f,0xf7bf,0xf7df,0xf7e7,0xf7ff,0xffff,0xffff,0xffff, //ī   
                                   0xffff,0xffff,0xf71f,0xf7ff,0xf407,0xf7bf,0xf7bf,0xc7bf,0xf75f,0xf6df,0xf5ef,0xf7f7,0xf7ff,0xffff,0xffff,0xffff, //            
                                   0xffff,0xffff,0xf607,0xf7f7,0xf7f7,0xf7f7,0xf607,0xc7f7,0xf7f7,0xf7f7,0xf7f7,0xf407,0xf7ff,0xffff,0xffff,0xffff, //Ÿ     
                                   0xffff,0xffff,0xf407,0xf7ff,0xf76f,0xf76f,0xf76f,0xc76f,0xf76f,0xf76f,0xf76f,0xf407,0xf7ff,0xffff,0xffff,0xffff, //          
                                   0xffff,0xffff,0xf78f,0xf7ff,0xf603,0xf7ff,0xf78f,0xc777,0xf777,0xf777,0xf777,0xf78f,0xf7ff,0xffff,0xffff,0xffff, //  
                                   0xffff,0xffff,0xffbf,0xffbf,0xff5f,0xff5f,0xfeef,0xfeef,0xfe0f,0xfdf7,0xfdf7,0xfdf7,0xffff,0xffff,0xffff,0xffff, //A     
                                   0xffff,0xffff,0xff07,0xfef7,0xfef7,0xfef7,0xff07,0xfef7,0xfef7,0xfef7,0xfef7,0xff07,0xffff,0xffff,0xffff,0xffff, //B      
                                   0xffff,0xffff,0xfe1f,0xfdef,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfdef,0xfe1f,0xffff,0xffff,0xffff,0xffff, //C           
                                   0xffff,0xffff,0xff87,0xff77,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xff77,0xff87,0xffff,0xffff,0xffff,0xffff, //D       
                                   0xffff,0xffff,0xfe07,0xfff7,0xfff7,0xfff7,0xfe07,0xfff7,0xfff7,0xfff7,0xfff7,0xfe07,0xffff,0xffff,0xffff,0xffff, //E  
                                   0xffff,0xffff,0xfe07,0xfff7,0xfff7,0xfff7,0xff07,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xffff,0xffff,0xffff,0xffff, //F
                                   0xffff,0xffff,0xfe1f,0xfdef,0xfff7,0xfff7,0xfc37,0xfdf7,0xfdf7,0xfdf7,0xfcef,0xfd1f,0xffff,0xffff,0xffff,0xffff, //G  
                                   0xffff,0xffff,0xfef7,0xfef7,0xfef7,0xfef7,0xfe07,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xffff,0xffff,0xffff,0xffff, //H  
                                   0xffff,0xffff,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xffff,0xffff,0xffff,0xffff, //I 
                                   0xffff,0xffff,0xffbf,0xffbf,0xffbf,0xffbf,0xffbf,0xffbf,0xffbf,0xffbb,0xffbb,0xffc7,0xffff,0xffff,0xffff,0xffff, //J  
                                   0xffff,0xffff,0xfef7,0xff77,0xffb7,0xffd7,0xffe7,0xffd7,0xffb7,0xff77,0xfef7,0xfdf7,0xffff,0xffff,0xffff,0xffff, //K             
                                   0xffff,0xffff,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfe07,0xffff,0xffff,0xffff,0xffff, //L        
                                   0xffff,0xffff,0xf7f7,0xf3e7,0xf3e7,0xf5d7,0xf5d7,0xf6b7,0xf6b7,0xf777,0xf777,0xf7f7,0xffff,0xffff,0xffff,0xffff, //M         
                                   0xffff,0xffff,0xfde7,0xfde7,0xfdd7,0xfdd7,0xfdb7,0xfdb7,0xfd77,0xfd77,0xfcf7,0xfcf7,0xffff,0xffff,0xffff,0xffff, //N     
                                   0xffff,0xffff,0xff1f,0xfeef,0xfdf7,0xfdf7,0xfdf7,0xfdf7,0xfdf7,0xfdf7,0xfeef,0xff1f,0xffff,0xffff,0xffff,0xffff, //O          
                                   0xffff,0xffff,0xff07,0xfef7,0xfef7,0xfef7,0xfef7,0xff07,0xfff7,0xfff7,0xfff7,0xfff7,0xffff,0xffff,0xffff,0xffff, //P  
                                   0xffff,0xffff,0xff1f,0xfeef,0xfdf7,0xfdf7,0xfdf7,0xfdf7,0xfdf7,0xfd77,0xfeef,0xfd1f,0xffff,0xffff,0xffff,0xffff, //Q   
                                   0xffff,0xffff,0xff07,0xfef7,0xfef7,0xfef7,0xff07,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xffff,0xffff,0xffff,0xffff, //R 
                                   0xffff,0xffff,0xff0f,0xfef7,0xfef7,0xfff7,0xffcf,0xff3f,0xfeff,0xfef7,0xfef7,0xff0f,0xffff,0xffff,0xffff,0xffff, //S        
                                   0xffff,0xffff,0xfc07,0xffbf,0xffbf,0xffbf,0xffbf,0xffbf,0xffbf,0xffbf,0xffbf,0xffbf,0xffff,0xffff,0xffff,0xffff, //T 
                                   0xffff,0xffff,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xfef7,0xff0f,0xffff,0xffff,0xffff,0xffff, //U    
                                   0xffff,0xffff,0xfdf7,0xfdf7,0xfdf7,0xfeef,0xfeef,0xfeef,0xff5f,0xff5f,0xffbf,0xffbf,0xffff,0xffff,0xffff,0xffff, //V           
                                   0xffff,0xffff,0xf777,0xf777,0xf777,0xfaaf,0xfaaf,0xfaaf,0xfaaf,0xfddf,0xfddf,0xfddf,0xffff,0xffff,0xffff,0xffff, //W
                                   0xffff,0xffff,0xfdf7,0xfdf7,0xfeef,0xff5f,0xffbf,0xffbf,0xff5f,0xfeef,0xfdf7,0xfdf7,0xffff,0xffff,0xffff,0xffff, //X
                                   0xffff,0xffff,0xfdf7,0xfdf7,0xfeef,0xfeef,0xff5f,0xff5f,0xffbf,0xffbf,0xffbf,0xffbf,0xffff,0xffff,0xffff,0xffff, //Y 
                                   0xffff,0xffff,0xfe07,0xfeff,0xff7f,0xffbf,0xffbf,0xffdf,0xffef,0xffef,0xfff7,0xfe07,0xffff,0xffff,0xffff,0xffff, //Z  
                                   0xffff,0xffff,0xf407,0xf7bf,0xf7bf,0xc75f,0xf6ef,0xf5f7,0xffff,0xf00f,0xf7ff,0xf7ff,0xf7ff,0xffff,0xffff,0xffff, //                                 
                                   0xffff,0xffff,0xf7bf,0xf7bf,0xf09f,0xf75f,0xf6ef,0xf5f7,0xffff,0xf81f,0xf7ef,0xf7ef,0xf81f,0xffff,0xffff,0xffff, //  
                                   0xffff,0xffff,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfff7,0xfe07,0xffff,0xffff,0xffff,0xffff, //L                                     
                                   0xffff,0xffff,0xfef7,0xff77,0xffb7,0xffd7,0xffe7,0xffd7,0xffb7,0xff77,0xfef7,0xfdf7,0xffff,0xffff,0xffff,0xffff, //K                                   
                                   0xffff,0xffff,0xf70f,0xf6f7,0xf6f7,0xf6f7,0xf70f,0xf7ff,0xffff,0xf00f,0xf7ef,0xf7ef,0xf00f,0xffff,0xffff,0xffff, //                                        
                                   0xffff,0xffff,0xf5b7,0xf5b7,0xf5b7,0xf5b7,0xf407,0xf5b7,0xf5b7,0xf5b7,0xf5b7,0xf587,0xf5ff,0xffff,0xffff,0xffff, //                          
                                   0xffff,0xffff,0xf607,0xf7f7,0xf7f7,0xf7f7,0xf7f7,0xf7f7,0xf7f7,0xf7f7,0xf7f7,0xf407,0xf7ff,0xffff,0xffff,0xffff, //                           
                                   0xffff,0xffff,0xf00f,0xffef,0xffef,0xffef,0xffef,0xf00f,0xffff,0xffff,0xffff,0xe007,0xffff,0xffff,0xffff,0xffff,  //
                                   };
                                   
volatile static int time_cnt=0;  
int toggle;                                 
// Timer 0 overflow interrupt service routine
ISR (TIMER0_OVF_vect)
{
static int i=0;
i++;
if(i==1000)
{
    time_cnt++;
    if(time_cnt==49)
    {
        time_cnt=0;  
       toggle^=1;
        }
        i=0;
        }
        TCNT0+=6;
} 
                                   
void main(void)
{
   
    //-- Ʈ ʱȭ! 
    PORTD=0xFF;DDRD=0xFF;       
    PORTC=0xFF;DDRC=0xFF;    
   
    TCCR0=0X04; //Overflow Interrupt, 64Prescaler Select
    TCNT0=6;    //Timer Counter Register set                                               
    TIMSK=1;    //Oveflow interrupt enable
    SREG=0X80;  //Global interrupt enable bit set            
    while(1)
    {
          
    int j=0;
    static unsigned int sum,rowsum=0;
          
        for(j=0;j<16;j++){                     
            if(toggle){
            //========Yellow LED ON===========        
            sum=str[time_cnt][j];         
            PORTD=(sum&0xff);   
            PORTC=0XFE;PORTC=0XFF;                  
                         
            PORTD=(sum>>8);
            PORTC=0XFD; PORTC=0XFF;     
            //========END=====================   
               
            //========RED LED OFF=============  
            PORTD=0xff;
            PORTC=0XFB; PORTC=0XFF;               
                     
            PORTD=0xff;
            PORTC=0XF7;PORTC=0XFF;   
            //========END=====================     
                   
            }            
            else{  
            //========Yellow LED OFF==========                             
            PORTD=0xff;   
            PORTC=0XFE;PORTC=0XFF;                  
           
            PORTD=0xff;
            PORTC=0XFD;PORTC=0XFF;  
            //========END====================  
            
            //========RED LED ON=============                  
            sum=str[time_cnt][j];         
            PORTD=(sum&0xff);
            PORTC=0XFB;PORTC=0XFF;                
                                          
            PORTD=(sum>>8);
            PORTC=0XF7;PORTC=0XFF; 
            //========END=====================    
            }           
                
            //========COMMON ANODE============                                   
            rowsum=row[j];              
            PORTD=rowsum&0xff;
            PORTC=0XEF;PORTC=0XFF;                
             
            PORTD=rowsum>>8;
            PORTC=0XDF;  PORTC=0XFF;   
            //========END======================      
            _delay_ms(1);   
                }  

    }

  }
